import { Base, Point, Type, INotifyPropertyChanged, IEnumerable, PropertyChangedEventArgs, EventArgs } from "igniteui-angular-core/ES2015/type";
import { TreemapViewRenderer } from "./TreemapViewRenderer";
import { DomRenderer } from "igniteui-angular-core/ES2015/dom";
import { FontInfo } from "igniteui-angular-core/ES2015/FontInfo";
import { Brush } from "igniteui-angular-core/ES2015/Brush";
import { Rect } from "igniteui-angular-core/ES2015/Rect";
import { Pool$1 } from "igniteui-angular-core/ES2015/Pool$1";
import { TreemapVisual } from "./TreemapVisual";
import { List$1 } from "igniteui-angular-core/ES2015/List$1";
import { HashSet$1 } from "igniteui-angular-core/ES2015/HashSet$1";
import { TreemapOrientation } from "./TreemapOrientation";
import { Dictionary$2 } from "igniteui-angular-core/ES2015/Dictionary$2";
import { DoubleAnimator } from "igniteui-angular-core/ES2015/DoubleAnimator";
import { BrushCollection } from "igniteui-angular-core/ES2015/BrushCollection";
import { TreemapFillScaleMode } from "./TreemapFillScaleMode";
import { TreemapLayoutType } from "./TreemapLayoutType";
import { FastItemsSource } from "igniteui-angular-core/ES2015/FastItemsSource";
import { IFastItemColumn$1 } from "igniteui-angular-core/ES2015/IFastItemColumn$1";
import { ObservableCollection$1 } from "igniteui-angular-core/ES2015/ObservableCollection$1";
import { FastItemsSourceEventAction } from "igniteui-angular-core/ES2015/FastItemsSourceEventAction";
import { TreemapValueMappingMode } from "./TreemapValueMappingMode";
import { TreemapNodePointerEventArgs } from "./TreemapNodePointerEventArgs";
/**
 * @hidden
 */
export declare class TreemapView extends Base {
    static $t: Type;
    constructor();
    protected b: TreemapViewRenderer;
    a: Treemap;
    at(): void;
    ax(): void;
    private m;
    ay(): void;
    ad(): void;
    n(): boolean;
    private ac;
    private j;
    private aa;
    private q;
    private p;
    private e;
    private ab;
    private t;
    au(): void;
    aq(a: DomRenderer): void;
    private ai;
    private ah;
    private z;
    an(): void;
    private ae;
    private ag;
    private ak;
    private aj;
    private c;
    protected am(): void;
    private r;
    private s;
    private a0;
    i(): Pool$1<TreemapVisual>;
    protected az(): void;
    ao(): void;
    al(): void;
    private aw;
    private g;
    as(a: FontInfo): void;
    private f;
    av(a: FontInfo): void;
    private o;
    private k;
    af(a: List$1<TreemapVisual>): void;
    y(a: string): number;
    w(a: string): number;
    u(a: FontInfo): number;
    x(a: string): number;
    v(a: string): number;
    a1(): Brush;
    a2(): Brush;
    a4(): Brush;
    a3(): Brush;
    a5(): Brush;
    private d;
    h(): FontInfo;
    private l;
    ap(): void;
    ar(): void;
}
/**
 * @hidden
 */
export declare abstract class TreemapLayoutCalculator extends Base {
    static $t: Type;
    abstract d(a: TreemapFrame, b: TreemapLayoutSettings): void;
    protected static c(a: TreemapTreeNode, b: Rect, c: TreemapLayoutSettings): boolean;
    protected static a(a: HashSet$1<TreemapTreeNode>, b: TreemapFrame, c: List$1<TreemapTreeNode>, d: Rect, e: TreemapLayoutSettings): boolean;
    protected static b(a: Rect, b: TreemapLayoutSettings): boolean;
    protected static f(a: HashSet$1<TreemapTreeNode>, b: TreemapFrame, c: List$1<TreemapTreeNode>, d: number, e: Rect, f: TreemapLayoutSettings): void;
    protected static e(a: HashSet$1<TreemapTreeNode>, b: TreemapFrame, c: List$1<TreemapTreeNode>, d: number, e: Rect, f: TreemapLayoutSettings): void;
}
/**
 * @hidden
 */
export declare class StrippedCalculator extends TreemapLayoutCalculator {
    static $t: Type;
    d(a: TreemapFrame, b: TreemapLayoutSettings): void;
    private n;
    protected l(a: TreemapFrame, b: TreemapTreeNode, c: Rect, d: TreemapLayoutSettings, e: number): void;
    private static j;
    private static i;
    private static k;
    private static g;
    private static h;
    private static m;
}
/**
 * @hidden
 */
export declare class SliceAndDiceCalculator extends TreemapLayoutCalculator {
    static $t: Type;
    d(a: TreemapFrame, b: TreemapLayoutSettings): void;
    private l;
    protected j(a: TreemapFrame, b: TreemapTreeNode, c: Rect, d: TreemapLayoutSettings, e: number): void;
    static g(a: TreemapTreeNode, b: TreemapLayoutSettings, c: number): TreemapOrientation;
    private static h;
    private static k;
    static i: any;
}
/**
 * @hidden
 */
export declare class TreemapLayoutSettings extends Base {
    static $t: Type;
    constructor();
    a: TreemapOrientation;
    h: Rect;
    b: TreemapTreeData;
    e: number;
    f: number;
    g: number;
    c: TreemapTreeNode;
    d: boolean;
}
/**
 * @hidden
 */
export declare class SquarifiedCalculator extends TreemapLayoutCalculator {
    static $t: Type;
    protected k(a: TreemapFrame, b: TreemapTreeNode, c: Rect, d: TreemapLayoutSettings, e: number): void;
    private l;
    private static g;
    private static i;
    private static j;
    private static h;
    d(a: TreemapFrame, b: TreemapLayoutSettings): void;
}
/**
 * @hidden
 */
export declare class TreemapTreeData extends Base {
    static $t: Type;
    constructor();
    a: TreemapTreeNode;
    b: Dictionary$2<string, TreemapTreeNode>;
    d: List$1<string>;
    c: Dictionary$2<string, List$1<TreemapTreeNode>>;
    e(a: TreemapTreeNode): void;
    private g;
    f(): void;
}
/**
 * @hidden
 */
export declare class TreemapTreeNode extends Base {
    static $t: Type;
    constructor();
    i: string;
    k: string;
    b: List$1<TreemapTreeNode>;
    c: List$1<TreemapNodeStyleMapping>;
    f: number;
    g: any;
    d: number;
    j: string;
    h: any;
    a: boolean;
    e(): number;
}
/**
 * @hidden
 */
export declare class Treemap extends Base implements INotifyPropertyChanged {
    static $t: Type;
    constructor();
    private d7;
    private d6;
    private ex;
    protected d9(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected g: TreemapFrame;
    protected f: TreemapFrame;
    protected e: TreemapFrame;
    notifySizeChanged(): void;
    destroy(): void;
    protected en(a: string, b: any, c: any): void;
    protected es(a: string, b: any, c: any): void;
    ae: TreemapView;
    private fk;
    fl: Rect;
    private d8;
    protected af: DoubleAnimator;
    private co;
    d3: string;
    private cn;
    dt: string;
    private ci;
    cq: string;
    private cm;
    dq: string;
    private cl;
    di: string;
    private cj;
    ct: string;
    private ck;
    dd: string;
    private bd;
    dataSource: IEnumerable;
    private a;
    b: BrushCollection;
    private v;
    readonly styleMappings: TreemapNodeStyleMappingCollection;
    private c;
    d: TreemapFillScaleMode;
    private a0;
    a5: boolean;
    private cd;
    cf: number;
    private bj;
    bw: number;
    private bi;
    bv: number;
    private e1;
    fe: Brush;
    private e0;
    fd: Brush;
    private e3;
    fg: Brush;
    private e5;
    fi: Brush;
    private e2;
    ff: Brush;
    private aj;
    am: FontInfo;
    private ai;
    al: FontInfo;
    private bm;
    b5: number;
    private bo;
    b7: number;
    private bn;
    b6: number;
    private bl;
    b4: number;
    private bk;
    b3: number;
    private e4;
    fh: Brush;
    private br;
    ca: number;
    private y;
    z: TreemapOrientation;
    private i;
    j: TreemapLayoutType;
    private bp;
    b8: number;
    private ce;
    ch: number;
    private bs;
    protected cb: number;
    private cc;
    private ag;
    ah: FastItemsSource;
    private ar;
    ay: IFastItemColumn$1<number>;
    private an;
    as: IFastItemColumn$1<any>;
    private aq;
    av: IFastItemColumn$1<any>;
    private ao;
    at: IFastItemColumn$1<any>;
    private ap;
    au: IFastItemColumn$1<any>;
    private bq;
    b9: number;
    private bf;
    bt: number;
    private az;
    protected aw(a: string): IFastItemColumn$1<number>;
    protected ax(a: string): IFastItemColumn$1<any>;
    ee(): void;
    protected a4: boolean;
    protected a7: boolean;
    protected a3: boolean;
    readonly a1: boolean;
    private ab;
    private aa;
    protected h: TreemapLayoutCalculator;
    protected er(): void;
    private a6;
    private bx;
    private bz;
    private b0;
    private by;
    private bg;
    d1(a: TreemapTreeNode, b: string, c: number, d: number, e: number): string;
    private c1;
    private bh;
    private b2;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    private e7;
    private fa;
    private ak;
    onDetachedFromUI(): void;
    onAttachedToUI(): void;
    private e8;
    private e9;
    private fb;
    private e6;
    private b1;
    private fc;
    protected eu(a: TreemapFrame): void;
    protected bb(): boolean;
    ev(): void;
    private a2;
    private ba;
    private bu;
    private a8;
    l(a: Point): TreemapNodeFrame;
    private cg;
    m(a: Point): TreemapNodeFrame;
    private ew;
    private readonly bc;
    provideContainer(a: DomRenderer): void;
    ec(): void;
    protected n: TreemapNodeFrame;
    private k;
    protected o: TreemapNodeFrame;
    private eb;
    private ed;
    private p;
    protected ad: TreemapTreeNode;
    protected ac: TreemapTreeNode;
    ei(a: Point): void;
    em(a: Point): void;
    private a9;
    ej(a: Point): void;
    ek(a: Point): void;
    protected fj: Point;
    protected ez(a: Point): void;
    el(a: Point): void;
    private ey;
    eo(a: Point): void;
    ep(a: Point): void;
    eq(a: TreemapNodeStyle): void;
    nodeStyling: (sender: any, args: TreemapNodeStylingEventArgs) => void;
    nodePointerOver: (sender: any, args: TreemapNodePointerEventArgs) => void;
    nodePointerEnter: (sender: any, args: TreemapNodePointerEventArgs) => void;
    nodePointerLeave: (sender: any, args: TreemapNodePointerEventArgs) => void;
    nodePointerPressed: (sender: any, args: TreemapNodePointerEventArgs) => void;
    nodePointerReleased: (sender: any, args: TreemapNodePointerEventArgs) => void;
}
/**
 * @hidden
 */
export declare class TreemapNodeStyle extends Base implements INotifyPropertyChanged {
    static $t: Type;
    a: Treemap;
    protected ag(a: string, b: any, c: any): void;
    private c;
    af(): void;
    b(a: string): boolean;
    protected ah(a: string, b: any, c: any): void;
    private ak;
    ar: Brush;
    private aj;
    aq: Brush;
    private am;
    at: Brush;
    private p;
    aa: string;
    private ao;
    av: Brush;
    private al;
    as: Brush;
    private f;
    l: number;
    private h;
    n: number;
    private g;
    m: number;
    private e;
    k: number;
    private d;
    j: number;
    private ai;
    ap: Brush;
    private an;
    au: Brush;
    private i;
    o: number;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
}
/**
 * @hidden
 */
export declare class TreemapNodeStyleMapping extends TreemapNodeStyle {
    static $t: Type;
    private a0;
    a3: number;
    private az;
    a2: number;
    private ay;
    a1: number;
    private a4;
    a5: any;
    private aw;
    ax: TreemapValueMappingMode;
}
/**
 * @hidden
 */
export declare class TreemapNodeStyleMappingCollection extends ObservableCollection$1<TreemapNodeStyleMapping> {
    static $t: Type;
    constructor();
    collectionResetting: (sender: any, e: EventArgs) => void;
    protected p(): void;
}
/**
 * @hidden
 */
export declare class TreemapNodeStylingEventArgs extends EventArgs {
    static $t: Type;
    private _value;
    value: number;
    private _sum;
    sum: number;
    private _customValue;
    customValue: any;
    private _item;
    item: any;
    private _parentItem;
    parentItem: any;
    private _label;
    label: string;
    private _parentValue;
    parentValue: number;
    private _parentLabel;
    parentLabel: string;
    private _parentSum;
    parentSum: number;
    private _style;
    style: TreemapNodeStyle;
}
/**
 * @hidden
 */
export declare class TreemapFrame extends Base {
    static $t: Type;
    constructor();
    private c;
    d: List$1<string>;
    g(a: number, b: TreemapFrame, c: TreemapFrame): void;
    i(a: TreemapTreeNode, b: Rect): void;
    j(a: TreemapTreeNode): Rect;
    h(a: TreemapTreeNode, b: string, c: Brush, d: Brush, e: Brush, f: Brush, g: number, h: number, i: number, j: number, k: number, l: number, m: number): void;
    f(): void;
    b(a: string): boolean;
    a(a: string): TreemapNodeFrame;
    e(a: TreemapTreeNode, b: TreemapNodeStyle): void;
}
/**
 * @hidden
 */
export declare class TreemapNodeFrame extends Base {
    static $t: Type;
    constructor();
    r: Rect;
    d: TreemapTreeNode;
    l: string;
    static a(a: number, b: TreemapNodeFrame, c: TreemapNodeFrame): TreemapNodeFrame;
    static c(a: number, b: TreemapNodeFrame): TreemapNodeFrame;
    static b(a: number, b: TreemapNodeFrame): TreemapNodeFrame;
    m: string;
    n: Brush;
    q: Brush;
    k: number;
    g: number;
    i: number;
    h: number;
    f: number;
    p: Brush;
    o: Brush;
    j: number;
    e: number;
}
